"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantStats(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "cohortId",
        "filterCount",
        "filterFreq",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.VariantStats": opencb_2_9_3.VariantStats,
        }

    __slots__ = [
        "cohortId",
        "filterCount",
        "filterFreq",
        "alleleCount",
        "altAlleleCount",
        "altAlleleFreq",
        "fileCount",
        "genotypeCount",
        "genotypeFreq",
        "maf",
        "mafAllele",
        "mgf",
        "mgfGenotype",
        "missingAlleleCount",
        "missingGenotypeCount",
        "qualityAvg",
        "qualityCount",
        "refAlleleCount",
        "refAlleleFreq",
        "sampleCount",
    ]

    def __init__(
        self,
        cohortId,
        filterCount,
        filterFreq,
        alleleCount=None,
        altAlleleCount=None,
        altAlleleFreq=None,
        fileCount=None,
        genotypeCount=dict,
        genotypeFreq=dict,
        maf=None,
        mafAllele=None,
        mgf=None,
        mgfGenotype=None,
        missingAlleleCount=None,
        missingGenotypeCount=None,
        qualityAvg=None,
        qualityCount=None,
        refAlleleCount=None,
        refAlleleFreq=None,
        sampleCount=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.VariantStats model.

        :param cohortId:
            Unique cohort identifier within the study.
        :type cohortId: str
        :param filterCount:
            The number of occurrences for each FILTER value in files from samples
            in this cohort reporting this variant. As each file can
            contain more than one filter value (usually separated by
            ';'), the total sum of counts could be greater than the
            count of files.
        :type filterCount: dict[str, int]
        :param filterFreq:
            Frequency of each filter calculated from the filterCount and
            filesCount, in the range [0,1]
        :type filterFreq: dict[str, float]
        :param alleleCount:
            Total number of alleles in called genotypes. It does not include
            missing alleles. This value is used as denominator for
            refAlleleFreq and altAlleleFreq.
        :type alleleCount: None | int
        :param altAlleleCount:
            Number of main alternate alleles found in this variants. It does not
            include secondary alternates.
        :type altAlleleCount: None | int
        :param altAlleleFreq:
            Alternate allele frequency calculated from altAlleleCount and
            alleleCount, in the range [0,1]
        :type altAlleleFreq: None | float
        :param fileCount:
            Count of files with samples from the cohort that reported this
            variant. This value is used as denominator for filterFreq.
        :type fileCount: None | int
        :param genotypeCount:
            Number of occurrences for each genotype. This does not include
            genotype with all alleles missing (e.g. ./.), but it
            includes partially missing genotypes like "./0" or "./1".
            Total sum of counts should be equal to the count of
            samples.
        :type genotypeCount: dict[str, int]
        :param genotypeFreq:
            Genotype frequency for each genotype found calculated from the
            genotypeCount and samplesCount, in the range [0,1] The sum
            of frequencies should be 1.
        :type genotypeFreq: dict[str, float]
        :param maf:
            Minor allele frequency. Frequency of the less common allele between
            the reference and the main alternate alleles. This value
            does not take into acconunt secondary alternates.
        :type maf: None | float
        :param mafAllele:
            Allele with minor frequency.
        :type mafAllele: None | str
        :param mgf:
            Minor genotype frequency. Frequency of the less common genotype seen
            in this variant. This value takes into account all values
            from the genotypeFreq map.
        :type mgf: None | float
        :param mgfGenotype:
            Genotype with minor frequency.
        :type mgfGenotype: None | str
        :param missingAlleleCount:
            Number of missing alleles.
        :type missingAlleleCount: None | int
        :param missingGenotypeCount:
            Number of genotypes with all alleles missing (e.g. ./.). It does not
            count partially missing genotypes like "./0" or "./1".
        :type missingGenotypeCount: None | int
        :param qualityAvg:
            The average Quality value for files with valid QUAL values from
            samples in this cohort reporting this variant. Some files
            may not have defined the QUAL value, so the sampling could
            be less than the filesCount.
        :type qualityAvg: None | float
        :param qualityCount:
            The number of files from samples in this cohort reporting this variant
            with valid QUAL values. This value is used as denominator
            to obtain the qualityAvg.
        :type qualityCount: None | int
        :param refAlleleCount:
            Number of reference alleles found in this variant.
        :type refAlleleCount: None | int
        :param refAlleleFreq:
            Reference allele frequency calculated from refAlleleCount and
            alleleCount, in the range [0,1]
        :type refAlleleFreq: None | float
        :param sampleCount:
            Count of samples with non-missing genotypes in this variant from the
            cohort. This value is used as denominator for
            genotypeFreq.
        :type sampleCount: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
